
  { ExtraHelp v1.00 - Jon Webb, july 7th 1996                       }
  { Freeware; please report bugs, bug fixes, comments, enhancements }
  { etc. to j.webb@marketresponse.nl                                }

  { Neither the author nor his employer can be held responsible for }
  { any damage caused by the use of this utility                    }

  { This unit contains the options dialog                           }

unit Options;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Dialogs;

type
  TOptionsDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Bevel1: TBevel;
    Label1: TLabel;
    HDXFile: TEdit;
    BrowseHDXBtn: TButton;
    Label2: TLabel;
    Label3: TLabel;
    AddPathBtn: TButton;
    AddHelpBtn: TButton;
    HDXDlg: TOpenDialog;
    HelpFileDlg: TOpenDialog;
    HelpFileList: TListBox;
    SearchPathList: TListBox;
    RemovePathBtn: TButton;
    RemoveHelpBtn: TButton;
    procedure BrowseHDXBtnClick(Sender: TObject);
    procedure AddPathBtnClick(Sender: TObject);
    procedure AddHelpBtnClick(Sender: TObject);
    procedure SearchPathListClick(Sender: TObject);
    procedure HelpFileListClick(Sender: TObject);
    procedure RemoveHelpBtnClick(Sender: TObject);
    procedure RemovePathBtnClick(Sender: TObject);
    procedure SearchPathListDblClick(Sender: TObject);
    procedure HelpFileListDblClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  OptionsDlg: TOptionsDlg;

implementation

{$R *.DFM}

uses sysutils, seldir, ExtraIni;

{------------------------- Read INI file -------------------------------}

procedure TOptionsDlg.FormShow(Sender: TObject);
  var Hdx: string;
begin
  ReadIniFile(Hdx, TStringList(SearchPathList.Items), TStringList(HelpFileList.Items));
  if HdxFile.Text = '' then
    HdxFile.Text := Hdx;
end;

{--------------------- OK clicked - write INI file ---------------------------}

procedure TOptionsDlg.OKBtnClick(Sender: TObject);
begin
  WriteIniFile(HDXFile.Text, TStringList(SearchPathList.Items), TStringList(HelpFileList.Items));
end;

{-------------------------- HDX file location --------------------------}

procedure TOptionsDlg.BrowseHDXBtnClick(Sender: TObject);
begin
  if hdxDlg.Execute then
    HdxFile.Text := hdxDlg.FileName;
end;

{-------------------------- Search paths -------------------------------}

{Add button clicked}

procedure TOptionsDlg.AddPathBtnClick(Sender: TObject);
  var SelectDirDlg: TSelectDirDlg;
begin
 selectDirDlg := TSelectDirDlg.Create(self);
 try
   if SelectDirDlg.ShowModal = mrOk then
   begin
     SearchPathList.ItemIndex := SearchPathList.Items.Add(selectDirDlg.dlb.directory);
     RemovePathBtn.Enabled := True;
   end;
 finally
   SelectDirDlg.Free;
 end;
end;

{Remove button clicked}

procedure TOptionsDlg.RemovePathBtnClick(Sender: TObject);
begin
  with SearchPathList do
  begin
    items.delete(itemindex);
    itemIndex := -1;
    RemovePathBtn.Enabled := False;
  end;
end;

{Listbox clicked - enable remove button}

procedure TOptionsDlg.SearchPathListClick(Sender: TObject);
begin
  if SearchPathList.ItemIndex>=0 then
    RemovePathBtn.Enabled := True;
end;

{Listbox doubleclicked - change entry}

procedure TOptionsDlg.SearchPathListDblClick(Sender: TObject);
  var SelectDirDlg: TSelectDirDlg;
      oldIndex: integer;
begin
 selectDirDlg := TSelectDirDlg.Create(self);
 try
   oldIndex := SearchPathList.ItemIndex;
   selectDirDlg.dlb.directory := SearchPathList.Items[oldIndex];
   if SelectDirDlg.ShowModal = mrOk then
   begin
     SearchPathList.Items[oldIndex] := selectDirDlg.dlb.directory;
     SearchPathList.ItemIndex := oldIndex;
     RemovePathBtn.Enabled := True;
   end;
 finally
   SelectDirDlg.Free;
 end;
end;

{---------------------- Additional help files --------------------------}

{Add button clicked}

procedure TOptionsDlg.AddHelpBtnClick(Sender: TObject);
begin
  if helpFileDlg.Execute then
  begin
    HelpFileList.ItemIndex := HelpFileList.Items.Add(helpFileDlg.FileName);
    RemoveHelpBtn.Enabled := True;
  end;
end;

{Remove button clicked...}

procedure TOptionsDlg.RemoveHelpBtnClick(Sender: TObject);
begin
  with HelpFileList do
  begin
    items.delete(itemindex);
    itemIndex := -1;
    RemoveHelpBtn.Enabled := False;
  end;
end;

{Listbox clicked - enable remove button}

procedure TOptionsDlg.HelpFileListClick(Sender: TObject);
begin
  if HelpFileList.ItemIndex>=0 then
    RemoveHelpBtn.Enabled := True;
end;

{Listbox doubleclicked - change entry}

procedure TOptionsDlg.HelpFileListDblClick(Sender: TObject);
  var oldIndex: integer;
begin
  oldIndex := HelpFileList.ItemIndex;
  helpFileDlg.FileName := HelpFileList.Items[oldIndex];
  if helpFileDlg.Execute then
  begin
    HelpFileList.Items[oldIndex] := helpFileDlg.FileName;
    HelpFileList.ItemIndex := oldIndex;
    RemoveHelpBtn.Enabled := True;
  end;
end;

end.
